/* imap-namespace-command.c generated by valac 0.52.4, the Vala compiler
 * generated from imap-namespace-command.vala, do not modify */

/*
 * Copyright 2016 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <gio/gio.h>
#include <glib.h>

enum  {
	GEARY_IMAP_NAMESPACE_COMMAND_0_PROPERTY,
	GEARY_IMAP_NAMESPACE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* geary_imap_namespace_command_properties[GEARY_IMAP_NAMESPACE_COMMAND_NUM_PROPERTIES];

static gpointer geary_imap_namespace_command_parent_class = NULL;

static GType geary_imap_namespace_command_get_type_once (void);

GearyImapNamespaceCommand*
geary_imap_namespace_command_construct (GType object_type,
                                        GCancellable* should_send)
{
	GearyImapNamespaceCommand * self = NULL;
	g_return_val_if_fail ((should_send == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (should_send, g_cancellable_get_type ()), NULL);
	self = (GearyImapNamespaceCommand*) geary_imap_command_construct (object_type, GEARY_IMAP_NAMESPACE_COMMAND_NAME, NULL, (gint) 0, should_send);
	return self;
}

GearyImapNamespaceCommand*
geary_imap_namespace_command_new (GCancellable* should_send)
{
	return geary_imap_namespace_command_construct (GEARY_IMAP_TYPE_NAMESPACE_COMMAND, should_send);
}

static void
geary_imap_namespace_command_class_init (GearyImapNamespaceCommandClass * klass,
                                         gpointer klass_data)
{
	geary_imap_namespace_command_parent_class = g_type_class_peek_parent (klass);
}

static void
geary_imap_namespace_command_instance_init (GearyImapNamespaceCommand * self,
                                            gpointer klass)
{
}

/**
 * The RFC 2342 NAMESPACE command.
 *
 * Determines the mailbox name prefix and hierarchy delimiter for the
 * personal, other user's and public namespaces.
 *
 * See [[https://tools.ietf.org/html/rfc2342|RFC 2342]] for details.
 */
 G_GNUC_NO_INLINE static GType
geary_imap_namespace_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearyImapNamespaceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_imap_namespace_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyImapNamespaceCommand), 0, (GInstanceInitFunc) geary_imap_namespace_command_instance_init, NULL };
	GType geary_imap_namespace_command_type_id;
	geary_imap_namespace_command_type_id = g_type_register_static (GEARY_IMAP_TYPE_COMMAND, "GearyImapNamespaceCommand", &g_define_type_info, 0);
	return geary_imap_namespace_command_type_id;
}

GType
geary_imap_namespace_command_get_type (void)
{
	static volatile gsize geary_imap_namespace_command_type_id__volatile = 0;
	if (g_once_init_enter (&geary_imap_namespace_command_type_id__volatile)) {
		GType geary_imap_namespace_command_type_id;
		geary_imap_namespace_command_type_id = geary_imap_namespace_command_get_type_once ();
		g_once_init_leave (&geary_imap_namespace_command_type_id__volatile, geary_imap_namespace_command_type_id);
	}
	return geary_imap_namespace_command_type_id__volatile;
}

